Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels) Summary: [Constants](https://developer.android.com/reference/android/provider/CallLog.Calls#constants) \| [Inherited Constants](https://developer.android.com/reference/android/provider/CallLog.Calls#inhconstants) \| [Fields](https://developer.android.com/reference/android/provider/CallLog.Calls#lfields) \| [Ctors](https://developer.android.com/reference/android/provider/CallLog.Calls#pubctors) \| [Methods](https://developer.android.com/reference/android/provider/CallLog.Calls#pubmethods) \| [Inherited Methods](https://developer.android.com/reference/android/provider/CallLog.Calls#inhmethods)

# CallLog.Calls

*** ** * ** ***


`
public
static


class
CallLog.Calls
`


`

extends https://developer.android.com/reference/java/lang/Object


`

`


implements

https://developer.android.com/reference/android/provider/BaseColumns


`

|---|---|
| [java.lang.Object](https://developer.android.com/reference/java/lang/Object) ||
| ↳ | android.provider.CallLog.Calls |

<br />

*** ** * ** ***

Contains the recent calls.


Note: If you want to query the call log and limit the results to a single value, you should
append the `https://developer.android.com/reference/android/provider/CallLog.Calls#LIMIT_PARAM_KEY` parameter to the content URI. For example:

    getContentResolver().query(
                    Calls.CONTENT_URI.buildUpon().appendQueryParameter(LIMIT_PARAM_KEY, "1")
                    .build(),
                    null, null, null, null);


The call log provider enforces strict SQL grammar, so you CANNOT append "LIMIT" to the SQL
query as below:

    getContentResolver().query(Calls.CONTENT_URI, null, "LIMIT 1", null, null);

<br />

## Summary

| ### Constants ||
|---|---|
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#ANSWERED_EXTERNALLY_TYPE` Call log type for a call which was answered on another device. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#ASSERTED_DISPLAY_NAME` String that stores the asserted display name associated with business call. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#AUTO_MISSED_EMERGENCY_CALL` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` to indicate that a call was automatically rejected by system because an ongoing emergency call. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#AUTO_MISSED_MAXIMUM_DIALING` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` to indicate that a call was automatically rejected by system because the system cannot support any more dialing calls. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#AUTO_MISSED_MAXIMUM_RINGING` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` to indicate that a call was automatically rejected by system because the system cannot support any more ringing calls. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#AUTO_MISSED_UNWANTED` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` to indicate that a call was automatically rejected by system because the call was marked as unwanted by the network. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` Call log type for calls blocked automatically. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON` Where the `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE`, indicates the reason why a call is blocked. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_BLOCKED_NUMBER` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because it is in the BlockedNumbers provider. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_CALL_SCREENING_SERVICE` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked by a CallScreeningService. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_DIRECT_TO_VOICEMAIL` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because the user configured a contact to be sent directly to voicemail. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_NOT_BLOCKED` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set as the default value when a call was not blocked by a CallScreeningService or any other system call blocking method. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_NOT_IN_CONTACTS` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because the user has chosen to block all calls from numbers not in their contacts. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_PAY_PHONE` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because the user has chosen to block all calls from pay phones. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_RESTRICTED_NUMBER` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because the user has chosen to block all calls from restricted numbers. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_UNKNOWN_NUMBER` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because the user has chosen to block all calls from unknown numbers. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CACHED_FORMATTED_NUMBER` The cached phone number, formatted with formatting rules based on the country the user was in when the call was made or received. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CACHED_LOOKUP_URI` The cached URI to look up the contact associated with the phone number, if it exists. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CACHED_MATCHED_NUMBER` The cached phone number of the contact which matches this entry, if it exists. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CACHED_NAME` The cached name associated with the phone number, if it exists. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CACHED_NORMALIZED_NUMBER` The cached normalized(E164) version of the phone number, if it exists. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CACHED_NUMBER_LABEL` The cached number label, for a custom number type, associated with the phone number, if it exists. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CACHED_NUMBER_TYPE` The cached number type (Home, Work, etc) associated with the phone number, if it exists. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CACHED_PHOTO_ID` The cached photo id of the picture associated with the phone number, if it exists. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CACHED_PHOTO_URI` The cached photo URI of the picture associated with the phone number, if it exists. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CALL_SCREENING_APP_NAME` The name of the app which blocked a call. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CALL_SCREENING_COMPONENT_NAME` The ComponentName of the CallScreeningService which blocked this call. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#COMPOSER_PHOTO_URI` A reference to the picture that was sent via call composer. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_ITEM_TYPE` The MIME type of a `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_URI` sub-directory of a single call. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_TYPE` The MIME type of `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_URI` and `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_FILTER_URI` providing a directory of calls. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#COUNTRY_ISO` The ISO 3166-1 two letters country code of the country where the user received or made the call. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#DATA_USAGE` The data usage of the call in bytes. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#DATE` The date the call occured, in milliseconds since the epoch Type: INTEGER (long) <br /> |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#DEFAULT_SORT_ORDER` The default sort order for this table |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#DURATION` The duration of the call in seconds Type: INTEGER (long) <br /> |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#EXTRA_CALL_TYPE_FILTER` An optional extra used with `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_TYPE` and `https://developer.android.com/reference/android/content/Intent#ACTION_VIEW` to specify that the presented list of calls should be filtered for a particular call type. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#FEATURES` Bit-mask describing features of the call (e.g. video). |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#FEATURES_ASSISTED_DIALING_USED` Indicates the call underwent Assisted Dialing. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#FEATURES_GROUP_CALL` Indicates that this was a group call. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#FEATURES_HD_CALL` Call was HD. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#FEATURES_HD_PLUS_CALL` Call was HD+ |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#FEATURES_PULLED_EXTERNALLY` Call was pulled externally. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#FEATURES_RTT` Call was on RTT at some point |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#FEATURES_VIDEO` Call had video. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#FEATURES_VOLTE` Call was VoLTE |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#FEATURES_VONR` Call used VoNR (Voice Over New Radio; aka 5G) (ie `https://developer.android.com/reference/android/telephony/TelephonyManager#NETWORK_TYPE_NR`). |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#FEATURES_WIFI` Call was WIFI call. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#GEOCODED_LOCATION` A geocoded location for the number associated with this call. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#INCLUDE_VOIP_CALLS_PARAM_KEY` An optional URI parameter which instructs the provider to allow the operation to be applied to VOIP call records as well. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#INCOMING_TYPE` Call log type for incoming calls. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#IS_BUSINESS_CALL` Boolean indicating whether the call is a business call. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#IS_READ` Whether this item has been read or otherwise consumed by the user. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#LAST_MODIFIED` The date the row is last inserted, updated, or marked as deleted, in milliseconds since the epoch. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#LIMIT_PARAM_KEY` Query parameter used to limit the number of call logs returned. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#LOCATION` A reference to the location that was sent via call composer. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON` Where the `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, indicates factors which may have lead the user to miss the call. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON_NOT_MISSED` Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON`, set as the default value when a call was not missed. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` Call log type for missed calls. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#NEW` Whether or not the call has been acknowledged Type: INTEGER (boolean) <br /> |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#NUMBER` The phone number as the user entered it. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#NUMBER_PRESENTATION` The number presenting rules set by the network. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#OFFSET_PARAM_KEY` Query parameter used to specify the starting record to return. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#OUTGOING_TYPE` Call log type for outgoing calls. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#PHONE_ACCOUNT_COMPONENT_NAME` The component name of the account used to place or receive the call; in string form. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#PHONE_ACCOUNT_ID` The identifier for the account used to place or receive the call. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#POST_DIAL_DIGITS` The post-dial portion of a dialed number, including any digits dialed after a `https://developer.android.com/reference/android/telecom/TelecomManager#DTMF_CHARACTER_PAUSE` or a `https://developer.android.com/reference/android/telecom/TelecomManager#DTMF_CHARACTER_WAIT` and these characters themselves. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#PREFERRED_DISPLAY_NAME` The preferred name associated with the phone number, if it exists. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#PRESENTATION_ALLOWED` Number is allowed to display for caller id. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#PRESENTATION_PAYPHONE` Number is a pay phone. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#PRESENTATION_RESTRICTED` Number is blocked by user. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#PRESENTATION_UNAVAILABLE` Number is unavailable. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#PRESENTATION_UNKNOWN` Number is not specified or unknown by network. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#PRIORITY` The priority of the call, as delivered via call composer. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#PRIORITY_NORMAL` Used as a value in the `https://developer.android.com/reference/android/provider/CallLog.Calls#PRIORITY` column. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#PRIORITY_URGENT` Used as a value in the `https://developer.android.com/reference/android/provider/CallLog.Calls#PRIORITY` column. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#REJECTED_TYPE` Call log type for calls rejected by direct user action. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#SUBJECT` The subject of the call, as delivered via call composer. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#TRANSCRIPTION` Transcription of the call or voicemail entry. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` The type of the call. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_CALL_FILTERS_TIMEOUT` When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when the call filters timed out. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_CALL_SCREENING_SERVICE_SILENCED` When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when this call is silenced by the call screening service. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_DND_MODE` When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when this call is silenced because the phone is in 'do not disturb mode'. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_LOW_RING_VOLUME` When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when this call rings with a low ring volume. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_NO_ANSWER` When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when the call was missed just because user didn't answer it. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_NO_VIBRATE` When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` set this bit when this call rings without vibration. |
| `long` | `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_SHORT_RING` When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when this call rang for a short period of time. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#UUID` Constant for the UUID column. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#VIA_NUMBER` For an incoming call, the secondary line number the call was received via. |
| `int` | `https://developer.android.com/reference/android/provider/CallLog.Calls#VOICEMAIL_TYPE` Call log type for voicemails. |
| `https://developer.android.com/reference/java/lang/String` | `https://developer.android.com/reference/android/provider/CallLog.Calls#VOICEMAIL_URI` URI of the voicemail entry. |

### Inherited constants

From interface `https://developer.android.com/reference/android/provider/BaseColumns` `https://developer.android.com/reference/java/lang/String` `https://developer.android.com/reference/android/provider/BaseColumns#_COUNT`

The count of rows in a directory.


`https://developer.android.com/reference/java/lang/String` `https://developer.android.com/reference/android/provider/BaseColumns#_ID`

The unique ID for a row.


| ### Fields ||
|---|---|
| ` public static final https://developer.android.com/reference/android/net/Uri` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_FILTER_URI` The content:// style URL for filtering this table on phone numbers |
| ` public static final https://developer.android.com/reference/android/net/Uri` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_URI` The content:// style URL for this table |
| ` public static final https://developer.android.com/reference/android/net/Uri` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_URI_WITH_VOICEMAIL` Content uri used to access call log entries, including voicemail records. |
| ` public static final https://developer.android.com/reference/android/net/Uri` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_URI_WITH_VOIP_CALLS` Content uri used to access call log entries, including VOIP call records. |
| ` public static final https://developer.android.com/reference/android/net/Uri` | `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_VOIP_URI` The content:// style URL for VoIP applications to query the data belongs to them. |

| ### Public constructors ||
|---|---|
| ` https://developer.android.com/reference/android/provider/CallLog.Calls#Calls()() ` |

| ### Public methods ||
|---|---|
| ` static https://developer.android.com/reference/java/lang/String` | ` https://developer.android.com/reference/android/provider/CallLog.Calls#getLastOutgoingCall(android.content.Context)(https://developer.android.com/reference/android/content/Context context) ` Query the call log database for the last dialed number. |

### Inherited methods

From class `

https://developer.android.com/reference/java/lang/Object

` `


https://developer.android.com/reference/java/lang/Object` `
https://developer.android.com/reference/java/lang/Object#clone()()
`

Creates and returns a copy of this object.


`


boolean` `
https://developer.android.com/reference/java/lang/Object#equals(java.lang.Object)(https://developer.android.com/reference/java/lang/Object obj)
`

Indicates whether some other object is "equal to" this one.


`


void` `
https://developer.android.com/reference/java/lang/Object#finalize()()
`

Called by the garbage collector on an object when garbage collection
determines that there are no more references to the object.


`


final

https://developer.android.com/reference/java/lang/Class<?>` `
https://developer.android.com/reference/java/lang/Object#getClass()()
`

Returns the runtime class of this `Object`.


`


int` `
https://developer.android.com/reference/java/lang/Object#hashCode()()
`

Returns a hash code value for the object.


`


final

void` `
https://developer.android.com/reference/java/lang/Object#notify()()
`

Wakes up a single thread that is waiting on this object's
monitor.


`


final

void` `
https://developer.android.com/reference/java/lang/Object#notifyAll()()
`

Wakes up all threads that are waiting on this object's monitor.


`


https://developer.android.com/reference/java/lang/String` `
https://developer.android.com/reference/java/lang/Object#toString()()
`

Returns a string representation of the object.


`


final

void` `
https://developer.android.com/reference/java/lang/Object#wait(long,%20int)(long timeoutMillis, int nanos)
`

Causes the current thread to wait until it is awakened, typically
by being *notified* or *interrupted*, or until a
certain amount of real time has elapsed.


`


final

void` `
https://developer.android.com/reference/java/lang/Object#wait(long)(long timeoutMillis)
`

Causes the current thread to wait until it is awakened, typically
by being *notified* or *interrupted*, or until a
certain amount of real time has elapsed.


`


final

void` `
https://developer.android.com/reference/java/lang/Object#wait()()
`

Causes the current thread to wait until it is awakened, typically
by being *notified* or *interrupted*.


## Constants

### ANSWERED_EXTERNALLY_TYPE

Added in [API level 25](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int ANSWERED_EXTERNALLY_TYPE
```

Call log type for a call which was answered on another device. Used in situations where
a call rings on multiple devices simultaneously and it ended up being answered on a
device other than the current one.

<br />

Constant Value:

7
(0x00000007)


### ASSERTED_DISPLAY_NAME

Added in [API level 35](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String ASSERTED_DISPLAY_NAME
```

String that stores the asserted display name associated with business call.

<br />

Constant Value:

"asserted_display_name"


### AUTO_MISSED_EMERGENCY_CALL

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final long AUTO_MISSED_EMERGENCY_CALL
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is
`https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` to indicate that a call was automatically rejected by
system because an ongoing emergency call.

<br />

Constant Value:

1
(0x0000000000000001)


### AUTO_MISSED_MAXIMUM_DIALING

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final long AUTO_MISSED_MAXIMUM_DIALING
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is
`https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` to indicate that a call was automatically rejected by
system because the system cannot support any more dialing calls.

<br />

Constant Value:

4
(0x0000000000000004)


### AUTO_MISSED_MAXIMUM_RINGING

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final long AUTO_MISSED_MAXIMUM_RINGING
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is
`https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` to indicate that a call was automatically rejected by
system because the system cannot support any more ringing calls.

<br />

Constant Value:

2
(0x0000000000000002)


### AUTO_MISSED_UNWANTED

Added in [version 37.2](https://developer.android.com/topic/libraries/support-library/revisions)

```
public static final long AUTO_MISSED_UNWANTED
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is
`https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` to indicate that a call was automatically rejected by
system because the call was marked as unwanted by the network.

<br />

Constant Value:

8
(0x0000000000000008)


### BLOCKED_TYPE

Added in [API level 24](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int BLOCKED_TYPE
```

Call log type for calls blocked automatically.

<br />

Constant Value:

6
(0x00000006)


### BLOCK_REASON

Added in [API level 29](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String BLOCK_REASON
```

Where the `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE`, indicates the
reason why a call is blocked.

Type: INTEGER


Allowed values:

- `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_NOT_BLOCKED`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_CALL_SCREENING_SERVICE`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_DIRECT_TO_VOICEMAIL`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_BLOCKED_NUMBER`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_UNKNOWN_NUMBER`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_RESTRICTED_NUMBER`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_PAY_PHONE`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON_NOT_IN_CONTACTS`

<br />

<br />

<br />

Constant Value:

"block_reason"


### BLOCK_REASON_BLOCKED_NUMBER

Added in [API level 29](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int BLOCK_REASON_BLOCKED_NUMBER
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is
`https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because it is in
the BlockedNumbers provider.

<br />

Constant Value:

3
(0x00000003)


### BLOCK_REASON_CALL_SCREENING_SERVICE

Added in [API level 29](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int BLOCK_REASON_CALL_SCREENING_SERVICE
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is
`https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked by a
CallScreeningService. The `https://developer.android.com/reference/android/provider/CallLog.Calls#CALL_SCREENING_COMPONENT_NAME` and
`https://developer.android.com/reference/android/provider/CallLog.Calls#CALL_SCREENING_APP_NAME` columns will indicate which call screening
service was responsible for blocking the call.

<br />

Constant Value:

1
(0x00000001)


### BLOCK_REASON_DIRECT_TO_VOICEMAIL

Added in [API level 29](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int BLOCK_REASON_DIRECT_TO_VOICEMAIL
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is
`https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because the user
configured a contact to be sent directly to voicemail.

<br />

Constant Value:

2
(0x00000002)


### BLOCK_REASON_NOT_BLOCKED

Added in [API level 29](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int BLOCK_REASON_NOT_BLOCKED
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set as the default value when a call was
not blocked by a CallScreeningService or any other system call blocking method.

<br />

Constant Value:

0
(0x00000000)


### BLOCK_REASON_NOT_IN_CONTACTS

Added in [API level 29](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int BLOCK_REASON_NOT_IN_CONTACTS
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is
`https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because the user
has chosen to block all calls from numbers not in their contacts.

<br />

Constant Value:

7
(0x00000007)


### BLOCK_REASON_PAY_PHONE

Added in [API level 29](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int BLOCK_REASON_PAY_PHONE
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is
`https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because the user
has chosen to block all calls from pay phones.

<br />

Constant Value:

6
(0x00000006)


### BLOCK_REASON_RESTRICTED_NUMBER

Added in [API level 29](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int BLOCK_REASON_RESTRICTED_NUMBER
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is
`https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because the user
has chosen to block all calls from restricted numbers.

<br />

Constant Value:

5
(0x00000005)


### BLOCK_REASON_UNKNOWN_NUMBER

Added in [API level 29](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int BLOCK_REASON_UNKNOWN_NUMBER
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCK_REASON`, set when `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is
`https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` to indicate that a call was blocked because the user
has chosen to block all calls from unknown numbers.

<br />

Constant Value:

4
(0x00000004)


### CACHED_FORMATTED_NUMBER

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CACHED_FORMATTED_NUMBER
```

The cached phone number, formatted with formatting rules based on the country the user
was in when the call was made or received.

This value is typically filled in by the dialer app for the caching purpose,
so it's not guaranteed to be present, and may not be current if the contact information
associated with this number has changed.

Type: TEXT

<br />

<br />

Constant Value:

"formatted_number"


### CACHED_LOOKUP_URI

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CACHED_LOOKUP_URI
```

The cached URI to look up the contact associated with the phone number, if it exists.

This value is typically filled in by the dialer app for the caching purpose,
so it's not guaranteed to be present, and may not be current if the contact information
associated with this number has changed.

Type: TEXT

<br />

<br />

Constant Value:

"lookup_uri"


### CACHED_MATCHED_NUMBER

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CACHED_MATCHED_NUMBER
```

The cached phone number of the contact which matches this entry, if it exists.

This value is typically filled in by the dialer app for the caching purpose,
so it's not guaranteed to be present, and may not be current if the contact information
associated with this number has changed.

Type: TEXT

<br />

<br />

Constant Value:

"matched_number"


### CACHED_NAME

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CACHED_NAME
```

The cached name associated with the phone number, if it exists.

This value is typically filled in by the dialer app for the caching purpose,
so it's not guaranteed to be present, and may not be current if the contact information
associated with this number has changed.

Type: TEXT

<br />

<br />

Constant Value:

"name"


### CACHED_NORMALIZED_NUMBER

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CACHED_NORMALIZED_NUMBER
```

The cached normalized(E164) version of the phone number, if it exists.

This value is typically filled in by the dialer app for the caching purpose,
so it's not guaranteed to be present, and may not be current if the contact information
associated with this number has changed.

Type: TEXT

<br />

<br />

Constant Value:

"normalized_number"


### CACHED_NUMBER_LABEL

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CACHED_NUMBER_LABEL
```

The cached number label, for a custom number type, associated with the phone number, if
it exists.

This value is typically filled in by the dialer app for the caching purpose,
so it's not guaranteed to be present, and may not be current if the contact information
associated with this number has changed.

Type: TEXT

<br />

<br />

Constant Value:

"numberlabel"


### CACHED_NUMBER_TYPE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CACHED_NUMBER_TYPE
```

The cached number type (Home, Work, etc) associated with the phone number, if it exists.

This value is typically filled in by the dialer app for the caching purpose,
so it's not guaranteed to be present, and may not be current if the contact information
associated with this number has changed.

Type: INTEGER

<br />

<br />

Constant Value:

"numbertype"


### CACHED_PHOTO_ID

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CACHED_PHOTO_ID
```

The cached photo id of the picture associated with the phone number, if it exists.

This value is typically filled in by the dialer app for the caching purpose,
so it's not guaranteed to be present, and may not be current if the contact information
associated with this number has changed.

Type: INTEGER (long)

<br />

<br />

Constant Value:

"photo_id"


### CACHED_PHOTO_URI

Added in [API level 23](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CACHED_PHOTO_URI
```

The cached photo URI of the picture associated with the phone number, if it exists.

This value is typically filled in by the dialer app for the caching purpose,
so it's not guaranteed to be present, and may not be current if the contact information
associated with this number has changed.

Type: TEXT (URI)

<br />

<br />

Constant Value:

"photo_uri"


### CALL_SCREENING_APP_NAME

Added in [API level 29](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CALL_SCREENING_APP_NAME
```

The name of the app which blocked a call. Will be populated when the
`https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE`. Provided as a
convenience so that the call log can still indicate which app blocked a call, even if
that app is no longer installed.

Type: TEXT

<br />

<br />

Constant Value:

"call_screening_app_name"


### CALL_SCREENING_COMPONENT_NAME

Added in [API level 29](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CALL_SCREENING_COMPONENT_NAME
```

The ComponentName of the CallScreeningService which blocked this call. Will be populated
when the `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE`.

Type: TEXT

<br />

<br />

Constant Value:

"call_screening_component_name"


### COMPOSER_PHOTO_URI

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String COMPOSER_PHOTO_URI
```

A reference to the picture that was sent via call composer.

The string contained in this field should be converted to an `https://developer.android.com/reference/android/net/Uri` via
`https://developer.android.com/reference/android/net/Uri#parse(java.lang.String)`, then passed to `https://developer.android.com/reference/android/content/ContentResolver#openFileDescriptor(android.net.Uri,%20java.lang.String)` in
order to obtain a file descriptor to access the picture data.

The user may choose to delete the picture associated with a call independently of the
call log entry, in which case `https://developer.android.com/reference/android/content/ContentResolver#openFileDescriptor(android.net.Uri,%20java.lang.String)` may throw a
`https://developer.android.com/reference/java/io/FileNotFoundException`.

Note that pictures sent or received via call composer will not be included in any backups
of the call log.

Type: TEXT

<br />

<br />

Constant Value:

"composer_photo_uri"


### CONTENT_ITEM_TYPE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CONTENT_ITEM_TYPE
```

The MIME type of a `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_URI` sub-directory of a single call.

<br />

Constant Value:

"vnd.android.cursor.item/calls"


### CONTENT_TYPE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String CONTENT_TYPE
```

The MIME type of `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_URI` and `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_FILTER_URI` providing a
directory of calls.

<br />

Constant Value:

"vnd.android.cursor.dir/calls"


### COUNTRY_ISO

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String COUNTRY_ISO
```

The ISO 3166-1 two letters country code of the country where the user received or made
the call.


Type: TEXT

<br />

<br />

Constant Value:

"countryiso"


### DATA_USAGE

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String DATA_USAGE
```

The data usage of the call in bytes.

Type: INTEGER (long)

<br />

<br />

Constant Value:

"data_usage"


### DATE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String DATE
```

The date the call occured, in milliseconds since the epoch

Type: INTEGER (long)

<br />

<br />

Constant Value:

"date"


### DEFAULT_SORT_ORDER

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String DEFAULT_SORT_ORDER
```

The default sort order for this table

<br />

Constant Value:

"date DESC"


### DURATION

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String DURATION
```

The duration of the call in seconds

Type: INTEGER (long)

<br />

<br />

Constant Value:

"duration"


### EXTRA_CALL_TYPE_FILTER

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String EXTRA_CALL_TYPE_FILTER
```

An optional extra used with `https://developer.android.com/reference/android/provider/CallLog.Calls#CONTENT_TYPE` and
`https://developer.android.com/reference/android/content/Intent#ACTION_VIEW` to specify that the presented list of calls should be filtered
for a particular call type.

Applications implementing a call log UI should check for this extra, and display a
filtered list of calls based on the specified call type. If not applicable within the
application's UI, it should be silently ignored.


The following example brings up the call log, showing only missed calls.

```
Intent intent = new Intent(Intent.ACTION_VIEW);
intent.setType(CallLog.Calls.CONTENT_TYPE);
intent.putExtra(CallLog.Calls.EXTRA_CALL_TYPE_FILTER, CallLog.Calls.MISSED_TYPE);
startActivity(intent);
```

<br />

<br />

<br />

Constant Value:

"android.provider.extra.CALL_TYPE_FILTER"


### FEATURES

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String FEATURES
```

Bit-mask describing features of the call (e.g. video).

Type: INTEGER (int)

<br />

<br />

Constant Value:

"features"


### FEATURES_ASSISTED_DIALING_USED

Added in [API level 30](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int FEATURES_ASSISTED_DIALING_USED
```

Indicates the call underwent Assisted Dialing.

<br />

**See also:**

- `https://developer.android.com/reference/android/telecom/TelecomManager#EXTRA_USE_ASSISTED_DIALING`

Constant Value:

16
(0x00000010)


### FEATURES_GROUP_CALL

Added in [API level 37](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int FEATURES_GROUP_CALL
```

Indicates that this was a group call.

<br />

Constant Value:

512
(0x00000200)


### FEATURES_HD_CALL

Added in [API level 26](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int FEATURES_HD_CALL
```

Call was HD.

<br />

Constant Value:

4
(0x00000004)


### FEATURES_HD_PLUS_CALL

Added in [API level 37](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int FEATURES_HD_PLUS_CALL
```

Call was HD+

<br />

Constant Value:

128
(0x00000080)


### FEATURES_PULLED_EXTERNALLY

Added in [API level 25](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int FEATURES_PULLED_EXTERNALLY
```

Call was pulled externally.

<br />

Constant Value:

2
(0x00000002)


### FEATURES_RTT

Added in [API level 28](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int FEATURES_RTT
```

Call was on RTT at some point

<br />

Constant Value:

32
(0x00000020)


### FEATURES_VIDEO

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int FEATURES_VIDEO
```

Call had video.

<br />

Constant Value:

1
(0x00000001)


### FEATURES_VOLTE

Added in [API level 30](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int FEATURES_VOLTE
```

Call was VoLTE

<br />

Constant Value:

64
(0x00000040)


### FEATURES_VONR

Added in [API level 37](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int FEATURES_VONR
```

Call used VoNR (Voice Over New Radio; aka 5G)
(ie `https://developer.android.com/reference/android/telephony/TelephonyManager#NETWORK_TYPE_NR`).

<br />

Constant Value:

256
(0x00000100)


### FEATURES_WIFI

Added in [API level 26](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int FEATURES_WIFI
```

Call was WIFI call.

<br />

Constant Value:

8
(0x00000008)


### GEOCODED_LOCATION

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String GEOCODED_LOCATION
```

A geocoded location for the number associated with this call.


The string represents a city, state, or country associated with the number.

Type: TEXT

<br />

<br />

Constant Value:

"geocoded_location"


### INCLUDE_VOIP_CALLS_PARAM_KEY

Added in [API level 37](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String INCLUDE_VOIP_CALLS_PARAM_KEY
```

An optional URI parameter which instructs the provider to allow the operation to be
applied to VOIP call records as well.


TYPE: Boolean

<br />

Constant Value:

"include_voip_calls"


### INCOMING_TYPE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int INCOMING_TYPE
```

Call log type for incoming calls.

<br />

Constant Value:

1
(0x00000001)


### IS_BUSINESS_CALL

Added in [API level 35](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String IS_BUSINESS_CALL
```

Boolean indicating whether the call is a business call.

<br />

Constant Value:

"is_business_call"


### IS_READ

Added in [API level 14](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String IS_READ
```

Whether this item has been read or otherwise consumed by the user.


Unlike the `https://developer.android.com/reference/android/provider/CallLog.Calls#NEW` field, which requires the user to have acknowledged the existence
of the entry, this implies the user has interacted with the entry.

Type: INTEGER (boolean)

<br />

<br />

Constant Value:

"is_read"


### LAST_MODIFIED

Added in [API level 24](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String LAST_MODIFIED
```

The date the row is last inserted, updated, or marked as deleted, in milliseconds since
the epoch. Read only.

Type: INTEGER (long)

<br />

<br />

Constant Value:

"last_modified"


### LIMIT_PARAM_KEY

Added in [API level 17](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String LIMIT_PARAM_KEY
```

Query parameter used to limit the number of call logs returned.


TYPE: integer

<br />

Constant Value:

"limit"


### LOCATION

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String LOCATION
```

A reference to the location that was sent via call composer.

This column contains the content URI of the corresponding entry in `https://developer.android.com/reference/android/provider/CallLog.Locations`
table, which contains the actual location data. The
`https://developer.android.com/reference/android/Manifest.permission#ACCESS_FINE_LOCATION` permission is required to access that
table.

If your app has the appropriate permissions, the location data may be obtained by
converting the value of this column to an `https://developer.android.com/reference/android/net/Uri` via `https://developer.android.com/reference/android/net/Uri#parse(java.lang.String)`, then passing
the result to `https://developer.android.com/reference/android/content/ContentResolver#query(android.net.Uri,%20java.lang.String[],%20android.os.Bundle,%20android.os.CancellationSignal)`.

The user may choose to delete the location associated with a call independently of the
call log entry, in which case the `https://developer.android.com/reference/android/database/Cursor` returned from
`https://developer.android.com/reference/android/content/ContentResolver#query(android.net.Uri,%20java.lang.String[],%20android.os.Bundle,%20android.os.CancellationSignal)` will either be `null` or empty, with
`https://developer.android.com/reference/android/database/Cursor#getCount()` returning `0`.

This column will not be populated when a call is received while the device is locked, and
it will not be part of any backups.

Type: TEXT

<br />

<br />

Constant Value:

"location"


### MISSED_REASON

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String MISSED_REASON
```

Where the `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, indicates
factors which may have lead the user to miss the call.

Type: INTEGER


There are two main cases. Auto missed cases and user missed cases. Default value is:

- `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON_NOT_MISSED`

<br />


Auto missed cases are those where a call was missed because it was not possible for the
incoming call to be presented to the user at all. Possible values are:

- `https://developer.android.com/reference/android/provider/CallLog.Calls#AUTO_MISSED_EMERGENCY_CALL`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#AUTO_MISSED_MAXIMUM_RINGING`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#AUTO_MISSED_MAXIMUM_DIALING`

<br />


User missed cases are those where the incoming call was presented to the user, but
factors such as a low ringing volume may have contributed to the call being missed.
Following bits can be set to indicate possible reasons for this:

- `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_SHORT_RING`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_DND_MODE`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_LOW_RING_VOLUME`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_NO_VIBRATE`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_CALL_SCREENING_SERVICE_SILENCED`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#USER_MISSED_CALL_FILTERS_TIMEOUT`

<br />

<br />

<br />

Constant Value:

"missed_reason"


### MISSED_REASON_NOT_MISSED

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final long MISSED_REASON_NOT_MISSED
```

Value for `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_REASON`, set as the default value when a call was
not missed.

<br />

Constant Value:

0
(0x0000000000000000)


### MISSED_TYPE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int MISSED_TYPE
```

Call log type for missed calls.

<br />

Constant Value:

3
(0x00000003)


### NEW

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String NEW
```

Whether or not the call has been acknowledged

Type: INTEGER (boolean)

<br />

<br />

Constant Value:

"new"


### NUMBER

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String NUMBER
```

The phone number as the user entered it.

Type: TEXT

<br />

<br />

Constant Value:

"number"


### NUMBER_PRESENTATION

Added in [API level 19](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String NUMBER_PRESENTATION
```

The number presenting rules set by the network.


Allowed values:

- `https://developer.android.com/reference/android/provider/CallLog.Calls#PRESENTATION_ALLOWED`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#PRESENTATION_RESTRICTED`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#PRESENTATION_UNKNOWN`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#PRESENTATION_PAYPHONE`
- `https://developer.android.com/reference/android/provider/CallLog.Calls#PRESENTATION_UNAVAILABLE`

<br />

Type: INTEGER

<br />

<br />

Constant Value:

"presentation"


### OFFSET_PARAM_KEY

Added in [API level 17](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String OFFSET_PARAM_KEY
```

Query parameter used to specify the starting record to return.


TYPE: integer

<br />

Constant Value:

"offset"


### OUTGOING_TYPE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int OUTGOING_TYPE
```

Call log type for outgoing calls.

<br />

Constant Value:

2
(0x00000002)


### PHONE_ACCOUNT_COMPONENT_NAME

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String PHONE_ACCOUNT_COMPONENT_NAME
```

The component name of the account used to place or receive the call; in string form.

Type: TEXT

<br />

<br />

Constant Value:

"subscription_component_name"


### PHONE_ACCOUNT_ID

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String PHONE_ACCOUNT_ID
```

The identifier for the account used to place or receive the call.

Type: TEXT

<br />

<br />

Constant Value:

"subscription_id"


### POST_DIAL_DIGITS

Added in [API level 24](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String POST_DIAL_DIGITS
```

The post-dial portion of a dialed number, including any digits dialed after a
`https://developer.android.com/reference/android/telecom/TelecomManager#DTMF_CHARACTER_PAUSE` or a
`https://developer.android.com/reference/android/telecom/TelecomManager#DTMF_CHARACTER_WAIT` and these characters themselves.

Type: TEXT

<br />

<br />

Constant Value:

"post_dial_digits"


### PREFERRED_DISPLAY_NAME

Added in [API level 37](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String PREFERRED_DISPLAY_NAME
```

The preferred name associated with the phone number, if it exists.

This value is typically filled in with the caller name presentation (CNAP) name to be
used as the preferred name that should be displayed in the call log. This is notified
from the network and propagated into
`https://developer.android.com/`. However, this field can
be extended to account for other use cases as well.

Type: TEXT

<br />

<br />

Constant Value:

"preferred_display_name"


### PRESENTATION_ALLOWED

Added in [API level 19](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int PRESENTATION_ALLOWED
```

Number is allowed to display for caller id.

<br />

Constant Value:

1
(0x00000001)


### PRESENTATION_PAYPHONE

Added in [API level 19](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int PRESENTATION_PAYPHONE
```

Number is a pay phone.

<br />

Constant Value:

4
(0x00000004)


### PRESENTATION_RESTRICTED

Added in [API level 19](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int PRESENTATION_RESTRICTED
```

Number is blocked by user.

<br />

Constant Value:

2
(0x00000002)


### PRESENTATION_UNAVAILABLE

Added in [API level 33](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int PRESENTATION_UNAVAILABLE
```

Number is unavailable.

<br />

Constant Value:

5
(0x00000005)


### PRESENTATION_UNKNOWN

Added in [API level 19](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int PRESENTATION_UNKNOWN
```

Number is not specified or unknown by network.

<br />

Constant Value:

3
(0x00000003)


### PRIORITY

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String PRIORITY
```

The priority of the call, as delivered via call composer.

For outgoing calls, contains the priority set by the local user. For incoming calls,
contains the priority set by the remote caller. If no priority was set or the call did
not include call composer elements, defaults to `https://developer.android.com/reference/android/provider/CallLog.Calls#PRIORITY_NORMAL`. Valid values
are `https://developer.android.com/reference/android/provider/CallLog.Calls#PRIORITY_NORMAL` and `https://developer.android.com/reference/android/provider/CallLog.Calls#PRIORITY_URGENT`.

Type: INTEGER

<br />

<br />

Constant Value:

"priority"


### PRIORITY_NORMAL

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int PRIORITY_NORMAL
```

Used as a value in the `https://developer.android.com/reference/android/provider/CallLog.Calls#PRIORITY` column.

Indicates that the call is of normal priority. This is also the default value for calls
that did not include call composer elements.

<br />

Constant Value:

0
(0x00000000)


### PRIORITY_URGENT

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int PRIORITY_URGENT
```

Used as a value in the `https://developer.android.com/reference/android/provider/CallLog.Calls#PRIORITY` column.

Indicates that the call is of urgent priority.

<br />

Constant Value:

1
(0x00000001)


### REJECTED_TYPE

Added in [API level 24](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int REJECTED_TYPE
```

Call log type for calls rejected by direct user action.

<br />

Constant Value:

5
(0x00000005)


### SUBJECT

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String SUBJECT
```

The subject of the call, as delivered via call composer.

For outgoing calls, contains the subject set by the local user. For incoming calls,
contains the subject set by the remote caller. May be null if no subject was set.

Type: TEXT

<br />

<br />

Constant Value:

"subject"


### TRANSCRIPTION

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String TRANSCRIPTION
```

Transcription of the call or voicemail entry. This will only be populated for call log
entries of type `https://developer.android.com/reference/android/provider/CallLog.Calls#VOICEMAIL_TYPE` that have valid transcriptions.

<br />

Constant Value:

"transcription"


### TYPE

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String TYPE
```

The type of the call.

Type: INTEGER (int)


Allowed values:

- `https://developer.android.com/reference/android/provider/CallLog.Calls#INCOMING_TYPE` - an incoming call which the user answered.
- `https://developer.android.com/reference/android/provider/CallLog.Calls#OUTGOING_TYPE` - an outgoing call which was placed by the user.
- `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` - a call that rang without the user answering it.
- `https://developer.android.com/reference/android/provider/CallLog.Calls#VOICEMAIL_TYPE` - a call log entry associated with voicemail.
- `https://developer.android.com/reference/android/provider/CallLog.Calls#REJECTED_TYPE` - an incoming call rejected by the user.
- `https://developer.android.com/reference/android/provider/CallLog.Calls#BLOCKED_TYPE` - the call was blocked by a `https://developer.android.com/reference/android/telecom/CallScreeningService`
or the system block list.
- `https://developer.android.com/reference/android/provider/CallLog.Calls#ANSWERED_EXTERNALLY_TYPE` - used for SIM twinning scenarios where a call may have been answered on another device.

<br />

<br />

<br />

Constant Value:

"type"


### USER_MISSED_CALL_FILTERS_TIMEOUT

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final long USER_MISSED_CALL_FILTERS_TIMEOUT
```

When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when
the call filters timed out.

<br />

Constant Value:

4194304
(0x0000000000400000)


### USER_MISSED_CALL_SCREENING_SERVICE_SILENCED

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final long USER_MISSED_CALL_SCREENING_SERVICE_SILENCED
```

When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when
this call is silenced by the call screening service.

<br />

Constant Value:

2097152
(0x0000000000200000)


### USER_MISSED_DND_MODE

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final long USER_MISSED_DND_MODE
```

When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when
this call is silenced because the phone is in 'do not disturb mode'.

<br />

Constant Value:

262144
(0x0000000000040000)


### USER_MISSED_LOW_RING_VOLUME

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final long USER_MISSED_LOW_RING_VOLUME
```

When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when
this call rings with a low ring volume.

<br />

Constant Value:

524288
(0x0000000000080000)


### USER_MISSED_NO_ANSWER

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final long USER_MISSED_NO_ANSWER
```

When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when
the call was missed just because user didn't answer it.

<br />

Constant Value:

65536
(0x0000000000010000)


### USER_MISSED_NO_VIBRATE

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final long USER_MISSED_NO_VIBRATE
```

When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE` set this bit when
this call rings without vibration.

<br />

Constant Value:

1048576
(0x0000000000100000)


### USER_MISSED_SHORT_RING

Added in [API level 31](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final long USER_MISSED_SHORT_RING
```

When `https://developer.android.com/reference/android/provider/CallLog.Calls#TYPE` is `https://developer.android.com/reference/android/provider/CallLog.Calls#MISSED_TYPE`, set this bit when
this call rang for a short period of time.

<br />

Constant Value:

131072
(0x0000000000020000)


### UUID

Added in [version 36.1](https://developer.android.com/topic/libraries/support-library/revisions)

```
public static final String UUID
```

Constant for the UUID column.

This column contains the UUID generated by Telecom when adding the call, which is
a unique identifier associated with a call. Applications can retrieve the value
using `https://developer.android.com/reference/android/telecom/CallControl#getCallId()` during the call session.

Type: TEXT

<br />

<br />

Constant Value:

"uuid"


### VIA_NUMBER

Added in [API level 24](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String VIA_NUMBER
```

For an incoming call, the secondary line number the call was received via. When a SIM
card has multiple phone numbers associated with it, the via number indicates which of the
numbers associated with the SIM was called.

<br />

Constant Value:

"via_number"


### VOICEMAIL_TYPE

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final int VOICEMAIL_TYPE
```

Call log type for voicemails.

<br />

Constant Value:

4
(0x00000004)


### VOICEMAIL_URI

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final String VOICEMAIL_URI
```

URI of the voicemail entry. Populated only for `https://developer.android.com/reference/android/provider/CallLog.Calls#VOICEMAIL_TYPE`.

Type: TEXT

<br />

<br />

Constant Value:

"voicemail_uri"


## Fields

### CONTENT_FILTER_URI

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final Uri CONTENT_FILTER_URI
```

The content:// style URL for filtering this table on phone numbers

<br />

### CONTENT_URI

Added in [API level 1](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final Uri CONTENT_URI
```

The content:// style URL for this table

<br />

### CONTENT_URI_WITH_VOICEMAIL

Added in [API level 21](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final Uri CONTENT_URI_WITH_VOICEMAIL
```

Content uri used to access call log entries, including voicemail records. You must have
the READ_CALL_LOG and WRITE_CALL_LOG permissions to read and write to the call log, as
well as READ_VOICEMAIL and WRITE_VOICEMAIL permissions to read and write voicemails.

<br />

### CONTENT_URI_WITH_VOIP_CALLS

Added in [API level 37](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static final Uri CONTENT_URI_WITH_VOIP_CALLS
```

Content uri used to access call log entries, including VOIP call records. You must have
the READ_CALL_LOG and WRITE_CALL_LOG permissions to read and write to the call log.

<br />

### CONTENT_VOIP_URI

Added in [version 36.1](https://developer.android.com/topic/libraries/support-library/revisions)

```
public static final Uri CONTENT_VOIP_URI
```

The content:// style URL for VoIP applications to query the data belongs to them.


Applications granted the MANAGE_OWN_CALLS permission can access their own logs.

<br />

## Public constructors

### Calls

```
public Calls ()
```

<br />

<br />

## Public methods

### getLastOutgoingCall

Added in [API level 8](https://developer.android.com/guide/topics/manifest/uses-sdk-element#ApiLevels)

```
public static String getLastOutgoingCall (Context context)
```

Query the call log database for the last dialed number.

<br />

| Parameters ||
|---|---|
| `context` | `Context`: Used to get the content resolver. <br /> |

| Returns ||
|---|---|
| `https://developer.android.com/reference/java/lang/String` | The last phone number dialed (outgoing) or an empty string if none exist yet. <br /> |